
public class Kennel
{
    /**
     * For each question, respond with
     * A.  Won't compile
     * B.  Compiles but gets runtime exception
     * C.  Runs without error
     */
    public static void main(String[] args)
    {
        Dog dog = new Dog();
        // 1. can we invoke a Hound's methods on a Dog?         
        dog.fetch();   

        Hound hound = new Hound();
        // 2. can we assign a Hound to a Dog without casting?
        dog = hound; 
        // 3. can we cast dog to a Hound
        hound = (Hound) dog;
        // 4. can we invoke fetch on the dog?
        hound.fetch();

        Dog rover = new Dog();
        rover = hound;
        // 5. What will print, Bark or Woof?
        rover.talk();
               
        dog = new Dog();
        // 6. can we cast a Dog to a Hound?
        hound = (Hound) dog;
        // 7. What will print, Bark or Woof?
        hound.talk(); 
    }

}
